//******************************************************************
// Get access to the JavaScript console (for debugging)
//******************************************************************

const WendellFreeLibraryTB_ConsoleService =
      Components.
          classes['@mozilla.org/consoleservice;1'].
              getService(Components.interfaces.nsIConsoleService);

//******************************************************************
// Log a message on the JavaScript console (for debugging)
//******************************************************************

function WendellFreeLibraryTB_Log(aMessage)
{
    WendellFreeLibraryTB_ConsoleService.logStringMessage('WendellFreeLibrary_Toolbar: ' + aMessage);
}

function WendellFreeLibraryTB_Include(uri)
{
	var service = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
					.getService(Components.interfaces["mozIJSSubScriptLoader"]);
	service.loadSubScript(uri);
}

//******************************************************************
// Get access to the preferences service
//******************************************************************
var WendellFreeLibraryTB_PrefService = 
        Components.classes["@mozilla.org/preferences-service;1"].
           getService(Components.interfaces.nsIPrefService);

//******************************************************************
// Get our preferences branch
//******************************************************************
var WendellFreeLibraryTB_Branch = 
        WendellFreeLibraryTB_PrefService.getBranch("wendelllibrarytoolbar.");


//******************************************************************
// Parent window
var WendellFreeLibraryTB_parent_window = null;

//******************************************************************
// Check to see if parent window is destroyed
//******************************************************************
function WendellFreeLibraryTB_ParentWindowIsDestroyed()
{
	try {
		var str = WendellFreeLibraryTB_parent_window.location + " ";
	} catch (e)
	{
		return true;
	}
	return false;
}


//******************************************************************
// Initialize the preferences dialog 
//******************************************************************
function WendellFreeLibraryTB_Prefs_Init()
{
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init()");
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init: opener = "+opener);
	if (opener && opener.location.href.indexOf("extensions.xul") != -1)
	{
		if (opener.opener && (opener.opener.location.href.indexOf("browser.xul") != -1))
		{
			// opened from the extensions window
			WendellFreeLibraryTB_parent_window = opener.opener;
		}
		else 
		{
			// possibly opened from the all-in-one sidebar
			var window_service = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						.getService(Components.interfaces.nsIWindowMediator);
			WendellFreeLibraryTB_parent_window = window_service.getMostRecentWindow("navigator:browser");
		}
	}
	else
	{
		// opened via the toolbar Menu
		WendellFreeLibraryTB_parent_window = opener;
	}

	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init: WendellFreeLibraryTB_parent_window = "+WendellFreeLibraryTB_parent_window);
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init: WendellFreeLibraryTB_parent_window.windowtype = "+WendellFreeLibraryTB_parent_window.windowtype);
	if (WendellFreeLibraryTB_ParentWindowIsDestroyed())
	{
		document.getElementById("WendellFreeLibraryTB-PrefDialog").cancelDialog();
		return;
	}
	var maxhistory   = WendellFreeLibraryTB_Branch.getIntPref("maxhistory");
	var target       = WendellFreeLibraryTB_Branch.getCharPref("target");
	
	WendellFreeLibraryTB_parent_window.WendellFreeLibrarytoolbar_preference_dialog = document.getElementById("WendellFreeLibraryTB-PrefDialog");
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init: WendellFreeLibraryTB_parent_window.WendellFreeLibrarytoolbar_preference_dialog = "+WendellFreeLibraryTB_parent_window.WendellFreeLibrarytoolbar_preference_dialog);
	var element = document.getElementById("WendellFreeLibraryTB-PrefDialog_MaxHistory");
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_Init: element = "+element+", maxhistory = "+maxhistory);
	element.value = maxhistory;
	element = document.getElementById("WendellFreeLibraryTB-PrefDialog_Target");
	element.value = target;
}

//******************************************************************
// Accept (OK) button
//******************************************************************
function WendellFreeLibraryTB_Prefs_OK()
{
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK()");
	if (WendellFreeLibraryTB_ParentWindowIsDestroyed())
	{
		document.getElementById("WendellFreeLibraryTB-PrefDialog").cancelDialog();
		return true;
	}
	var element = document.getElementById("WendellFreeLibraryTB-PrefDialog_MaxHistory");
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: element is "+element);
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: element.value is "+element.value);
	var maxhistory   = parseInt(element.value);
	WendellFreeLibraryTB_Branch.setIntPref("maxhistory",maxhistory);
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: maxhistory = "+maxhistory);
	element = document.getElementById("WendellFreeLibraryTB-PrefDialog_Target");
	WendellFreeLibraryTB_Branch.setCharPref("target",element.value);
	
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: WendellFreeLibraryTB_parent_window = "+WendellFreeLibraryTB_parent_window);
	try {
		var status = WendellFreeLibraryTB_parent_window.setTimeout(
			function (parent) { parent.WendellFreeLibraryTB_PreferencesAccepted(); },
			 0, WendellFreeLibraryTB_parent_window);
		WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: status = "+status);
	} catch (e) {
		WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_Prefs_OK: e = "+e);
	}
	return true;	
}


//******************************************************************
// Cancel button
//******************************************************************
function WendellFreeLibraryTB_Prefs_Cancel()
{
	if (!WendellFreeLibraryTB_ParentWindowIsDestroyed())
	{
		WendellFreeLibraryTB_parent_window.WendellFreeLibrarytoolbar_preference_dialog = null;
	}
	return true;
}
